/**
 * 	\file		errore.c
 *  \brief 		Implementazioni delle funzioni di debugging del codice
 *	\author		Tranchida Giulio, No Matricola 241732\n
 *				Si dichiara che il contenuto di questo file e',
 * 				in ogni sua parte, opera originale dell'autore.
 *  \version	2.0
 *  \copyright (C) 2011 Tranchida Giulio under GNU Public License v3.\n\n
 *		This program is free software: you can redistribute it and/or modify
 * 		it under the terms of the GNU General Public License as published by
 * 		the Free Software Foundation, either version 3 of the License, or
 * 		(at your option) any later version.\n\n
 * 		This program is distributed in the hope that it will be useful,
 * 		but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * 		GNU General Public License for more details.\n\n
 * 		You should have received a copy of the GNU General Public License
 * 		along with this program.\n
 * 		If not, see <http://www.gnu.org/licenses/>.*/

#include "errore.h"

#ifdef _DEBUG_MODE

int sys_err(const char *file, int line, const char *format, ...){
	va_list arg;

	fprintf(stderr,"Errore file %s, linea %d. Error No: %d\n", file, line-1, errno);
	va_start (arg, format);
	vfprintf(stderr, format, arg);
	va_end (arg);
	perror(0);
	return errno;
}

void gen_err(const char *file, int line, const char *format, ...){
	va_list arg;

	fprintf(stderr,"Errore file %s, linea %d\n", file, line-1);
	va_start (arg, format);
	vfprintf(stderr, format, arg);
	va_end (arg);
	return;
}

#else

int sys_err(const char *file, int line, const char *format, ...){
	return errno;
}

void gen_err(const char *file, int line, const char *format, ...){
	return;
}

#endif
