/**
 * 	\file		main.c
 *	\author		Tranchida Giulio, No Matricola 241732\n
 *				Si dichiara che il contenuto di questo file e',
 * 				in ogni sua parte, opera originale dell'autore.\n\n
 *
 * This program is free software; you can redistribuite it and/or modify
 * it under the terms of the GNU/General Pubblic License as published the
 * Free software Foundation; either version 2 of the License, or
 * (at your opinion) any later version.
 * */
#include <stdio.h>
#include <unistd.h>
#include "thpool.h"
#include "errore.h"

/*static int r=0;	/**< Conto le eseguizioni di test */

/** job fittizio */
void *test(void * arg){
	printf("Hello World !\n");
	return 0;
}

/** main */
int main(int argc,char* argv[]){
	int i=0;
	th_pool * pool = NULL;
	sigset_t set;	/**< Maschera dei segnali per il pool */

	/* Questa maschera ignora tutti i segnali */
	if (sigfillset(&set) == -1){
		sys_err(__FILE__,__LINE__,"Main: error sigfillset",errno);
		exit(EXIT_FAILURE);
	}

	/* Inizializzo un pool di thread di dimensione 5 e
	 * con un numero massimo di job in attesa nella coda di 10 */
	if (!(pool = poolInit(5, 10, &set))){
		exit(EXIT_FAILURE);
	}

	/* Creo dei job fittizzi da fare eseguire al pool */
	for (i=0; i<20; i++){
		while (poolDispatcher(pool, test, NULL)==-5){
			sleep (1);
		}
	}

	/* Arresto il pool di threads e libero le risorse */
	poolDestroy(pool);

	return 0;
}
